/*

 ideserv - Very incomplete and buggy X1541 PCLink server for IDEDOS 0.9x

 Written by
  Kajtar Zsolt <soci@c64.rulez.org>

    This file is part of IDEDOS the IDE64 disk operating system
    See README for copyright notice.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <sys/io.h>
#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include <pwd.h>
#include <grp.h>
#include <err.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>
#include <argp.h>
#include <sys/resource.h>
#include <stdlib.h>
FILE *lf;
#include "ideserv.h"
#include "crc8.h"

#define CM_FILE 1
#define CM_DIR 2

#define OPEN_RONLY 0
#define OPEN_RW 2
#define OPEN_WONLY 4
#define OPEN_ERR 6

const char *argp_program_version="ideservd 0.12";
FILE *files[16];
int channelmode[16];
unsigned char buffer[16][65536];
unsigned short int buffbytes[16];
unsigned short int buffp[16];

void commandchannel(char *s) {
    unsigned char b;
	if (!strncmp(s,"CD:",3) || !strncmp(s,"CD/",3)) {
	    for (b=0;s[b];b++) s[b]=c64toascii[(unsigned char)s[b]];
	    if (chdir(&s[3])) strcpy(buffer[15],"80, ERROR,000,000,000,000\r");
	    else strcpy(buffer[15],"00, OK,000,000,000,000\r");
	    fprintf(lf,"Chdir \"%s\"\n",&s[3]);
	} else
	if (!strncmp(s,"MD:",3)) {
	    for (b=0;s[b];b++) s[b]=c64toascii[(unsigned char)s[b]];
	    if (mkdir(&s[3],0777)) strcpy(buffer[15],"80, ERROR,000,000,000,000\r");
	    else strcpy(buffer[15],"00, OK,000,000,000,000\r");
	    buffbytes[15]=strlen(buffer[15]);
	    buffp[15]=0;
	    fprintf(lf,"Mkdir \"%s\"\n",&s[3]);
	} else
	if (!strncmp(s,"CD_",3)) {
	    if (chdir("..")) strcpy(buffer[15],"80, ERROR,000,000,000,000\r");
	    else strcpy(buffer[15],"00, OK,000,000,000,000\r");
	    fprintf(lf,"Chdir \"..\"\n");
	} else
	if (!strncmp(s,"C\xd0",2)) {
	    fprintf(lf,"Change to partition %d\n",s[3]);
	} else
	if (!strncmp(s,"UI",2)) {
	    strcpy(buffer[15],"73, IDESERV 0.12 PCLINK,000,000,000,000\r");
	    buffbytes[15]=strlen(buffer[15]);
	    buffp[15]=0;
	    fprintf(lf,"Identify device\n");
	} else
	if (!strncmp(s,"I",1)) {
	    chdir("/");
	    fprintf(lf,"Initialize\n");
	} else 
	if (s[0]) {
	    strcpy(buffer[15],"31, UNKNOWN COMMAND,000,000,000,000\r");
	    buffbytes[15]=strlen(buffer[15]);
	    buffp[15]=0;
	} else fprintf(lf,"\n");
}

void openfile(int usecrc) {
    char s[100];
    unsigned char status=OPEN_ERR;
    unsigned char channel,ch;
    unsigned long long l=0;

    channel=(ch=getb()) & 0x0f;if (tout) return;
    if (channel==15) {
	int b=0;
	while (b<99 && (s[b++]=getb())) if (tout) return;
	s[b]=0;

	if (usecrc) {
	    unsigned char crc=crc8[0xCF];
	    crc=crc8[crc ^ ch];
	    b=0;
	    while (s[b]) { crc=crc8[crc ^ s[b]]; b++;}
	    crc=crc8[crc ^ getb()];if (tout) return;
	    getb();if (tout) return;
	    fprintf(lf,"%02X\n",crc);
	}

	files[15]=(void *)1;
	alarm(0);
	fprintf(lf,"Open [15]: \"%s\": ",s);
//	for (b=0;s[b];b++) fprintf(lf," %02X",s[b]);
//	fprintf(lf,"\n");
	commandchannel(s);
	status=OPEN_RONLY;
    } else {
	int b=0;
	while (b<99 && (s[b++]=getb())) if (tout) return;
	s[b]=0;
	
	if (usecrc) {
	    unsigned char crc=crc8[0xCF];
	    crc=crc8[crc ^ ch];
	    b=0;
	    while (s[b]) { crc=crc8[crc ^ s[b]]; b++;} 
	    crc=crc8[crc ^ getb()];if (tout) return;
	    getb();if (tout) return;
	    if (crc) {fprintf(lf,"CRC error\n");return;}
	}
	b=0;
	while (s[b]) {s[b]=c64toascii[(int)s[b]];b++;}

	fprintf(lf,"Open [%d]: \"%s\"\n",channel,s);

    if (files[channel] && channelmode[channel]==CM_FILE) fclose(files[channel]);
    if (s[0]=='$') {
	unsigned char dirline[32];
	struct dirent *ep;
	DIR *dp;
	int sum=0;
	channelmode[channel]=CM_DIR;
	files[channel]=(void *)1;
	buffbytes[channel]=buffp[channel]=0;

	if (!s[1]) {s[1]='.';s[2]=0;}
	dp=opendir(&s[1]);
	if (!dp) {sendb(1);fprintf(lf,"Couldn't open the directory.\n");return;}
	sendb(0);
	memcpy(&dirline[0x00],"\1\4\1\1\1\0\22\42",8);
	memset(&dirline[0x08],32,16);
	memcpy(&dirline[0x18],"\42\40LINUX\0",8);
	for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];

	while ((ep=readdir(dp)))
	{
	    struct stat buf;
	    int offs,n;
	    char *p,i[1000];
	    strncpy(i,&s[1],999);
	    strncat(i,"/",999);
	    strncat(i,ep->d_name,999);
            if (lstat(i,&buf)) break;

	    //                fprintf(lf,"%s %d ",&i,buf.st_size);
	    buf.st_size=(buf.st_size+255)>>8;
	    if (buf.st_size>65535) buf.st_size=65535;

	    dirline[0x00]=1;
	    dirline[0x01]=1;
	    dirline[0x02]=buf.st_size & 0xff;
	    dirline[0x03]=buf.st_size>>8 & 0xff;
	    memset(&dirline[0x04],32,27);
	    offs=7;
	    if (buf.st_size>9) offs--;
	    if (buf.st_size>99) offs--;
	    if (buf.st_size>999) offs--;
	    dirline[offs++]=0x22;
	    n=0;while (ep->d_name[n] && ep->d_name[n]!=',' && n<16) dirline[offs++]=topetscii[(int)ep->d_name[n++]];
	    dirline[offs++]=0x22;
	    offs+=(16-n);

	    dirline[offs++]=0x20;
	    if (S_ISDIR(buf.st_mode)) p="dir";
	    else if (S_ISREG(buf.st_mode)) {
                p=&ep->d_name[n+1];
		if (ep->d_name[n]!=',') {if (buf.st_mode & S_IXUSR) p="prg"; else p="";}
	    }
	    else if (S_ISLNK(buf.st_mode)) p="lnk";
	    else p="";

	    n=0;while (p[n] && n<3) dirline[offs++]=topetscii[(int)p[n++]];
	    dirline[offs]=access(i,W_OK)?'<':' ';

	    for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];
	    sum+=buf.st_size;
	    if (sum>65535) sum=65535;
	    }

	dirline[0x00]=1;
	dirline[0x01]=1;
	dirline[0x02]=sum & 0xff;
	dirline[0x03]=sum>>8 & 0xff;
	memcpy(&dirline[0x04],"BLOCKS USED.             \0\0\0",28);

	for (l=0;l<32;l++) buffer[channel][buffbytes[channel]++]=dirline[l];
	closedir(dp);
	status=OPEN_RONLY;
    } else {
        switch (channel) {
	case 0:files[channel]=fopen(s,"rb");if (files[channel]) status=OPEN_RONLY;break;
	case 1:files[channel]=fopen(s,"wb");if (files[channel]) status=OPEN_WONLY;break;
	default:files[channel]=fopen(s,"rb");if (files[channel]) status=OPEN_RONLY;break;
	}
	channelmode[channel]=CM_FILE;
}
    }
    sendb(status);
}

void closefile(int usecrc) {
    unsigned char channel,ch;
    channel=(ch=getb()) & 0x0f;if (tout) return;
    if (usecrc) {
        unsigned char crc=crc8[0xC3];
        crc=crc8[crc ^ ch];
        crc=crc8[crc ^ getb()];if (tout) return;
	getb();if (tout) return;
        if (crc) {fprintf(lf,"CRC error\n");return;}
    } else {
	getb();if (tout) return;
    }
    fprintf(lf,"Close [%d]\n",channel);
    if (channel!=15) {
	if (files[channel] && channelmode[channel]==CM_FILE) fclose(files[channel]);
    }
    files[channel]=NULL;
}

void readfile(int usecrc) {
    unsigned char channel,ch,status=0;
    unsigned short int bytes,i,j;
    struct timeval start,end;
    unsigned long long l=0;

    channel=(ch=getb()) & 0x0f;if (tout) return;
    bytes=getb();if (tout) return;
    bytes|=getb()*256;if (tout) return;
    if (usecrc) {
        unsigned char crc=crc8[0xD2];
        crc=crc8[crc ^ ch];
        crc=crc8[crc ^ (bytes & 0xff)];
        crc=crc8[crc ^ ((bytes >> 8) & 0xff)];
        crc=crc8[crc ^ getb()];if (tout) return;
	getb();if (tout) return;
        if (crc) {fprintf(lf,"CRC error\n");return;}
    } else {
	getb();if (tout) return;
    }
    fprintf(lf,"Read [%d] %d bytes\n",channel,bytes);
    sendb(0);if (tout) return;
    if (!files[channel]) {sendb(0);if (tout) return;sendb(0);if (tout) return;sendb(0);return;}
    if (channel==15) {
	j=buffp[channel];
	if (bytes==(buffbytes[channel]-j)) status=0x40;
	if (bytes>buffbytes[channel]-j) {bytes=buffbytes[channel]-j;status=0x42;}
	l=bytes;
	buffp[channel]+=bytes;
    } else {
	if (channelmode[channel]==CM_FILE) {
	    unsigned long itt;
	    l=bytes=fread(buffer[channel],1,bytes?bytes:65536,files[channel]);
	    itt=ftell(files[channel]);
	    fgetc(files[channel]);
	    if (feof(files[channel])) status=0x40;
	    fseek(files[channel],itt,SEEK_SET);
	    j=0;
	} else {
	    j=buffp[channel];
	    if (bytes==(buffbytes[channel]-j)) status=0x40;
	    if (bytes>buffbytes[channel]-j) {bytes=buffbytes[channel]-j;status=0x42;}
	    l=bytes;
	    buffp[channel]+=bytes;
	}
    }
    sendb(~bytes);if (tout) return;
    sendb(~bytes >> 8);if (tout) return;
    gettimeofday(&start,NULL);
    if (bytes)
    for (i=0;i<bytes;i++,j++) {sendb(buffer[channel][j]);if (tout) return;}
    else {
	for (i=0;i<32768;i++,j++) {sendb(buffer[channel][j]);if (tout) return;}
	for (i=0;i<32768;i++,j++) {sendb(buffer[channel][j]);if (tout) return;}
    }
    gettimeofday(&end,NULL);
    l=l*1000000/((end.tv_sec-start.tv_sec)*1000000+end.tv_usec-start.tv_usec);
    fprintf(lf,"Read %d bytes at %lld bytes/seconds\n",bytes,l);
    sendb(status);//fprintf(lf,"Status: %02X\n",status);
    if (channel==15 && buffbytes[15]==buffp[15]) {
	strcpy(buffer[15],"00, OK,000,000,000,000\r");
	buffbytes[15]=23;
	buffp[15]=0;
    }
}

void writefile(int usecrc) {
    unsigned char channel,ch;
    unsigned short int bytes,i;
    struct timeval start,end;
    unsigned long long l=0;

    channel=(ch=getb()) & 0x0f;if (tout) return;
    bytes=getb();if (tout) return;
    bytes|=getb()*256;if (tout) return;
    if (usecrc) {
        unsigned char crc=crc8[0xD7];
        crc=crc8[crc ^ ch];
        crc=crc8[crc ^ (bytes & 0xff)];
        crc=crc8[crc ^ ((bytes >> 8) & 0xff)];
        crc=crc8[crc ^ getb()];if (tout) return;
	getb();if (tout) return;
        if (crc) {fprintf(lf,"CRC error\n");return;}
    } else {
	getb();if (tout) return;
    }
    fprintf(lf,"Write [%d] %d bytes\n",channel,bytes);
    if (!files[channel] || channelmode[channel]!=CM_FILE) {fprintf(lf,"Not writeable.\n");sendb(1);return;}
    sendb(0);if (tout) return;

    gettimeofday(&start,NULL);
    for (i=0;i<bytes;i++) {buffer[channel][i]=getb();if (tout) return;}
    gettimeofday(&end,NULL);

    getb();if (tout) return;
    fwrite(buffer[channel],1,bytes,files[channel]);
    l=bytes;
    l=l*1000000/((end.tv_sec-start.tv_sec)*1000000+end.tv_usec-start.tv_usec);
    fprintf(lf,"Wrote %d bytes at %lld bytes/seconds\n",bytes,l);
    sendb(0);
}

const char *argp_program_bug_address="<soci@c64.rulez.org>";
static char doc[]="IDEDOS 0.9x PCLink fileserver";

static struct argp_option options[]={
    {"user",		'u',	"USER",		0,  "User under we run (nobody)"},
    {"group",		'g',	"GROUP",	0,  "Group under we run (nogroup)"},
    {"root",		'r',	"DIRECTORY",	0,  "Root directory (.)"},
    {"log",		'l',	"FILE",		0,  "Logfile (stdout)"},
    {"nice",		'n',	"ADJUST",	0,  "Adjust nice level (19)"},
    {"hog",		'h',	0,		0,  "CPU hog (off)"},
    {"background",	'b',	0, 		0,  "Fork into background"},
    { 0 }
};

struct arguments
{
    int background;
    int priority;
    char *user;
    char *group;
    char *root;
    char *log;
    int hog;
};

static error_t parse_opt (int key,char *arg,struct argp_state *state)
{
    struct arguments *arguments=state->input;

    switch (key)
    {
    case 'b':arguments->background=1;break;
    case 'h':arguments->hog=1;break;
    case 'u':arguments->user=arg;break;
    case 'g':arguments->group=arg;break;
    case 'l':arguments->log=arg;break;
    case 'r':arguments->root=arg;break;
    case 'n':arguments->priority=strtol(arg,NULL,0);printf("%s\n",arg);break;
    case ARGP_KEY_ARG:argp_usage(state);break;
    case ARGP_KEY_END:break;
    default:return ARGP_ERR_UNKNOWN;
    }
    return 0;
}

static struct argp argp={options,parse_opt,NULL,doc};

int vtime=1;

void init(int argc,char *argv[])
{
    struct passwd *user2;
    struct group *group2;
    struct arguments arguments;
    arguments.background=0;
    arguments.user= "nobody";
    arguments.group= "nogroup";
    arguments.root= ".";
    arguments.log= "/dev/stdout";
    arguments.priority=19;
    arguments.hog=0;
    argp_parse(&argp, argc, argv, 0, 0, &arguments);

    if (ioperm(IOPORT,3,1)) err(1,"Allocating IO ports");

    if (!(user2=getpwnam(arguments.user))) errx(1,"User %s does not exists.",arguments.user);
    if (!(group2=getgrnam(arguments.group))) errx(1,"Group %s does not exists.",arguments.group);
    if (!(lf=fopen(arguments.log,"wt"))) err(1,"Opening logfile '%s'",arguments.log);
    if (chdir(arguments.root) || chroot(arguments.root)) err(1,"Changeing root dir to '%s'",arguments.root);
    if (setgid(group2->gr_gid) || setuid(user2->pw_uid)) errx(1,"Could not drop privileges.");
    if (arguments.background) if (fork()) errx(0,"Forking into background.");
    nice(arguments.priority);
    if (arguments.hog) vtime=0;
    fclose(stdin);
    fclose(stderr);
    fclose(stdout);
}

int main(int argc,char *argv[]) {
    unsigned char b;

    init(argc,argv);
    fprintf(lf,"%s\n",argp_program_version);
    signal(SIGALRM,timeout);
    signal(SIGTERM,terminate);
    for (b=0;b<16;b++) files[b]=NULL;
    strcpy(buffer[15],"73, IDESERV 0.12 PCLINK,000,000,000,000\r");
    buffbytes[15]=40;
    buffp[15]=0;
start:
    fprintf(lf,"ready.\n");
    alarm(0);
    outb(CLKLO+DATAHI+ATNHI,CTRLPORT);
    wdatalo() if (vtime) usleep(100000);
    outb(CLKHI+DATAHI+ATNHI,CTRLPORT);
    tout=0;alarm(1);
    wdatahi() {if (vtime) usleep(10000);if (tout) goto start;} //set clklo, wait atnlo

    b=getb();if (tout) goto start;
    alarm(0);
    switch (b)
    {
//    case 'X':return 0;
    case 'O':openfile(0);break;
    case 0xCF:openfile(1);break;
    case 'R':readfile(0);break;
    case 0xD2:readfile(1);break;
    case 'W':writefile(0);break;
    case 0xD7:writefile(1);break;
    case 'C':closefile(0);break;
    case 0xC3:closefile(1);break;
    }
    goto start;
}
